Gecode::BinaryPropagator< View, pc > Class Template Reference

Binary propagator. More...

`#include <pattern.hpp>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low binary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| BinaryPropagator (Space &home, BinaryPropagator &p)
| Constructor for cloning p.
| BinaryPropagator (Home home, View x0, View x1)
| Constructor for creation.
| BinaryPropagator (Space &home, Propagator &p, View x0, View x1)
| Constructor for rewriting p during cloning.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

View | x0
| Two views.
View | x1

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class View, PropCond pc>
class Gecode::BinaryPropagator< View, pc >

Binary propagator.

Stores two views of type View with propagation condition pc.

If the propagation condition pc has the value PC_GEN_NONE, no subscriptions are created.

Definition at line 84 of file pattern.hpp.

## Constructor & Destructor Documentation

## BinaryPropagator() [1/3]

template<class View, PropCond pc>

Gecode::BinaryPropagator< View, pc >::BinaryPropagator | ( | Space & | home,
|  | BinaryPropagator< View, pc > & | p )

protected

Constructor for cloning p.

## BinaryPropagator() [2/3]

template<class View, PropCond pc>

Gecode::BinaryPropagator< View, pc >::BinaryPropagator | ( | Home | home,
|  | View | x0,
|  | View | x1 )

protected

Constructor for creation.

Definition at line 353 of file pattern.hpp.

## BinaryPropagator() [3/3]

template<class View, PropCond pc>

Gecode::BinaryPropagator< View, pc >::BinaryPropagator | ( | Space & | home,
|  | Propagator & | p,
|  | View | x0,
|  | View | x1 )

inline protected

Constructor for rewriting p during cloning.

Definition at line 372 of file pattern.hpp.

## Member Function Documentation

## cost()

template<class View, PropCond pc>

PropCost Gecode::BinaryPropagator< View, pc >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low binary).

Implements Gecode::Propagator.

Reimplemented in Gecode::Int::Arithmetic::AbsBnd< View >, Gecode::Int::Arithmetic::AbsDom< View >, Gecode::Int::Arithmetic::NrootDom< Ops >, Gecode::Int::Arithmetic::NrootPlusDom< Ops, minus >, Gecode::Int::Arithmetic::PowDom< Ops >, Gecode::Int::Bool::NaryEqv, Gecode::Int::Bool::NaryOrTrue< BV >, Gecode::Int::Distinct::EqIte, and Gecode::Int::Linear::NqBoolInt< VX >.

Definition at line 381 of file pattern.hpp.

## reschedule()

template<class View, PropCond pc>

void Gecode::BinaryPropagator< View, pc >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 387 of file pattern.hpp.

## dispose()

template<class View, PropCond pc>

size_t Gecode::BinaryPropagator< View, pc >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Reimplemented in Gecode::Int::Bool::NaryEqv, Gecode::Int::Bool::NaryOrTrue< BV >, and Gecode::Int::Linear::NqBoolInt< VX >.

Definition at line 396 of file pattern.hpp.

## Member Data Documentation

## x0

template<class View, PropCond pc>

View Gecode::BinaryPropagator< View, pc >::x0

protected

Two views.

Definition at line 87 of file pattern.hpp.

## x1

template<class View, PropCond pc>

View Gecode::BinaryPropagator< View, pc >::x1

protected

Definition at line 87 of file pattern.hpp.

The documentation for this class was generated from the following file:

- gecode/kernel/propagator/pattern.hpp